package scripts;

import java.util.Stack;
import util.ArraySet;
import java.util.ArrayList;
import java.util.HashMap;
import java.io.*;
import gnu.trove.map.hash.TIntDoubleHashMap;;

public class FlowSample {

	public static void readEdges(
			String edgeFilename,
			HashMap<String, Integer> geneNameToId,
			String[] geneIdToName,
			TIntDoubleHashMap[] edges)
	{
		try {
			ArrayList<ArrayList<Integer>> edgesTemp = new ArrayList<ArrayList<Integer>>();
			ArrayList<ArrayList<Byte>> edgesTypeTemp = new ArrayList<ArrayList<Byte>>();
			ArrayList<ArrayList<Double>> edgeCostTemp = new ArrayList<ArrayList<Double>>();
			BufferedReader edgeFileBr = new BufferedReader(new FileReader(edgeFilename));
			String line = edgeFileBr.readLine();

			int numEdges = 0;
			for (int lineNum = 1; line != null; ++lineNum) {
				String [] splitLine = line.split("\t");
				if (splitLine.length != 4) {
					throw new IOException("Line in edge file doesn't have 4 fields");
				}

				for (int i=0; i<splitLine.length; ++i) {
					splitLine[i] = splitLine[i].trim();
				}

				if (!splitLine[1].equals("(pp)") && !splitLine[1].equals("(pd)") && !splitLine[1].equals("(ptm)")) {
					throw new IOException("Field 1 has illegal type edge " + splitLine[1] + " on line " + lineNum);
				}

				if (splitLine[0].equals("")) {
					throw new IOException("Field 0 has empty gene name on line " + lineNum);
				}
				if (splitLine[2].equals("")) {
					throw new IOException("Field 2 has empty gene name on line " + lineNum);
				}

				if (!geneNameToId.containsKey(splitLine[0])) {
					geneNameToId.put(splitLine[0], edgesTemp.size());
					edgesTemp.add(new ArrayList<Integer>());
					edgeCostTemp.add(new ArrayList<Double>());
					edgesTypeTemp.add(new ArrayList<Byte>());
				}
				if (!geneNameToId.containsKey(splitLine[2])) {
					geneNameToId.put(splitLine[2], edgesTemp.size());
					edgesTemp.add(new ArrayList<Integer>());
					edgeCostTemp.add(new ArrayList<Double>());
					edgesTypeTemp.add(new ArrayList<Byte>());
				}

				edgesTemp.get(geneNameToId.get(splitLine[0])).add(geneNameToId.get(splitLine[2]));
				edgeCostTemp.get(geneNameToId.get(splitLine[0])).add(Double.parseDouble(splitLine[3]));
				++numEdges;

				if (splitLine[1].equals("(pd)")) {
					edgesTypeTemp.get(geneNameToId.get(splitLine[0])).add((byte)2);
				}
				else if (splitLine[1].equals("(ptm)")) {
					edgesTypeTemp.get(geneNameToId.get(splitLine[0])).add((byte)1);
				}
				else if (splitLine[1].equals("(pp)")) {
					edgesTypeTemp.get(geneNameToId.get(splitLine[0])).add((byte)0);
				}

				line = edgeFileBr.readLine();
			}
			edgeFileBr.close();

			/*
			int numNodes = geneNameToId.size();
			edges = new ArraySet[numNodes];
			for (int i=0; i<numEdges; ++i) {
				edges[i] = new ArraySet(numNodes);
			}

			for (int i=0, k=0; i<numNodes; ++i) {
				for (int j=0; j<edgesTemp.get(i).size(); ++j, ++k) {
					edges[i].add(edgesTemp.get(i).get(j));
				}
			}
			*/
		}
		catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	public static void readNodes(
			String nodeFile,
			HashMap<String, Integer> geneNameToId,
			ArraySet nodes)
	{
		try {
			BufferedReader edgeFileBr = new BufferedReader(new FileReader(nodeFile));
			String line = edgeFileBr.readLine();
			while (line != null) {
				nodes.add(geneNameToId.get(line.trim()));
			}
			edgeFileBr.close();
		}
		catch(Exception e) {
			e.printStackTrace();
		}
	}

	public static void main(String[] args) {
		/*
		if (args.length < 5) {
			System.err.println("Usage: <edge file> <sources files file;file;...> <targets files> <numSamples> <node prior>");
			System.exit(1);
		}

		String edgeFilename = args[0];
		String [] sourcesFiles = args[1].split(";");
		String [] targFiles = args[2].split(";");
		int numSamples = Integer.parseInt(args[3]);
		double nodePrior = Double.parseDouble(args[4]);
		
		HashMap<String, Integer> geneNameToId = new HashMap<String, Integer>();
		ArraySet [] edges = null;
		readEdges(edgeFilename, geneNameToId, edges);
		
		int numNodes = geneNameToId.size();
		ArraySet sources = new ArraySet(numNodes);
		ArraySet targs = new ArraySet(numNodes);
		
		for (String sourceFile : sourcesFiles) {
			readNodes(sourceFile, geneNameToId, sources);
		}
		for (String targFile : targFiles) {
			readNodes(targFile, geneNameToId, targs);
		}
		
		
		ArraySet nodesInCurPath = new ArraySet(numNodes);
		int [] stack = new int[numNodes*2];
		
		for (int sourceIndex=0; sourceIndex<sources.size(); ++sourceIndex) {
			nodesInCurPath.clear();
			for (int i=0; i<stack.length; ++i) {
				stack[i] = -1;
			}
			int source = sources.get(sourceIndex);
			
			stack[0] = source;
			int stackSize = 1;
			nodesInCurPath.add(source);
			double curWeight = 1.;
			
			while (nodesInCurPath.size() > 0)  {
			}
		}
		*/
	}
}
