package util;

import java.util.Random;

public class Algorithm {
	public static <T> void shuffleArray(T[] ar, Random rnd)
	{
		for (int i = ar.length - 1; i >= 0; i--)
		{
			int index = rnd.nextInt(i + 1);
			// Simple swap
			T a = ar[index];
			ar[index] = ar[i];
			ar[i] = a;
		}
	}

	public static void shuffleArray(int[] ar, Random rnd)
	{
		for (int i = ar.length - 1; i >= 0; i--)
		{
			int index = rnd.nextInt(i + 1);
			// Simple swap
			int a = ar[index];
			ar[index] = ar[i];
			ar[i] = a;
		}
	}

	public static void shuffleArray(int[] ar, Random rnd, int numElements)
	{
		assert (numElements >= 1 && numElements <= ar.length) : "numElements value invalid : 1 <= " + numElements + " <= " + ar.length;
		for (int i = 0; i < ar.length && i < numElements; ++i)
		{
			int index = rnd.nextInt(ar.length-i);
			// Simple swap
			int a = ar[index];
			ar[index] = ar[i];
			ar[i] = a;
		}
	}
}
