package util;

public class ArrayMap<V> {
	private ArraySet set;
	private V [] values;

	public ArrayMap(int max_card) {
		this(max_card, 0);
	}

	public ArrayMap(int max_card, int offset) {
		set = new ArraySet(max_card, offset);
		values = (V[]) new Object[max_card];
	}
	
	public boolean add(int key, V value) {
		boolean b = set.add(key);
		values[key] = value;
		return b;
	}
	
	public boolean remove(int key) {
		return set.remove(key);
	}
	
	public void set(int key, V value) {
		assert set.contains(key);
		values[key] = value;
	}
	
	public V get(int key) {
		assert (set.contains(key)) : "Set doesn't contain key " + key;
		return values[key];
	}
	
	public int size() {
		return set.size();
	}
	
	public ArraySet getSet() {
		return set;
	}
}
