package util;

public class ArrayMapInt {
	public ArraySet set;
	public int [] values;

	public ArrayMapInt(int max_card) {
		this(max_card, 0);
	}

	public ArrayMapInt(int max_card, int offset) {
		set = new ArraySet(max_card, offset);
		values = new int[max_card];
	}
	
	public boolean add(int key, int value) {
		boolean b = set.add(key);
		values[key] = value;
		return b;
	}
	
	public boolean remove(int key) {
		return set.remove(key);
	}
	
	public void set(int key, int value) {
		assert set.contains(key);
		values[key] = value;
	}
	
	public int get(int key) {
		assert (set.contains(key)) : "Set doesn't contain key " + key;
		return values[key];
	}
	
	public int getByIndex(int index) {
		return values[set.get(index)];
	}
	
	public int size() {
		return set.size();
	}
	
	public ArraySet getSet() {
		return set;
	}
}